<bugID>1222047<Summary>Mainstream front creation via Toolbox or Target</Summary><Description># Developer story:
------------------

We keep adding:
 * fields like inspector, highlighter, performance,
 * init methods like initInspector, initPerformance,
 * destroy methods like destoryInspector, destroyPerformance.
 * manualy add calls to these init and destroy methods from initialization and destruction codepath of the toolbox
all in toolbox.js.

That doesn't scale!

Like actors on the server, we should have an easy way to manage :
 * initialisation,
 * destruction,
 * retrieval 
of client/fronts for any actor. That, without having to hack so many garbage into toolbox.js!

Offering such abstraction is going to:
 + help us restrict actor specifics to the actor files
 + ease playing with new actors from anywhere
 + keep us sane


# Proposal:
-----------

What about exposing something like:

  getFront(name) =&gt; promise of the front

Or, with some more magic:

  fronts.`name` =&gt; promise of the front

Also, I wouldn't expose that on toolbox. I think it would be handy in some other cases where we don't have a toolbox to expose that via `target` or `client` objects.

Then we would have to still declare the Fronts somehow, like what we are doing for Actors. But that will just be a list of module paths with all necessary arguments that may help implementing all that.

I would first do that for a new kind of front that I need to access. (Here the Preference front) Then, I think it is still doable to rework existing usages as there isn't that many usages of toolbox.`front` attributes in our codebase. Obvious inspector is going to be painful because of all these races it has on destruction, but it would be worth it!


# What is wrong today in our code:
----------------------------------

This won't scale:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#283
Neither that:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#1943
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#1952

There is too many actor specifics here:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#1788
Even worse here:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#1814
Too many performance specifics in toolbox:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/framework/toolbox.js#2046

We do things similar in WebIDE for other actors, but that ends up only be accessible to WebIDE codebase whereas it could be useful anywhere:
http://mxr.mozilla.org/mozilla-central/source/devtools/client/webide/modules/app-manager.js#559</Description></bugID>